
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Selfie_referencesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const selfie_references = await db.selfie_references.create(
            {
                id: data.id || undefined,
        
        status: data.status
        ||
        null
            ,
            
        uploaded_at: data.uploaded_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await selfie_references.setUser( data.user || null, {
            transaction,
        });
        
        await selfie_references.setAi_model( data.ai_model || null, {
            transaction,
        });
        
        await selfie_references.setSelfie_embedding( data.selfie_embedding || null, {
            transaction,
        });
        
        await selfie_references.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.selfie_references.getTableName(),
                belongsToColumn: 'selfie_image',
                belongsToId: selfie_references.id,
            },
            data.selfie_image,
            options,
        );
        

        return selfie_references;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const selfie_referencesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                status: item.status
            ||
            null
            ,
            
                uploaded_at: item.uploaded_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const selfie_references = await db.selfie_references.bulkCreate(selfie_referencesData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < selfie_references.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.selfie_references.getTableName(),
                    belongsToColumn: 'selfie_image',
                    belongsToId: selfie_references[i].id,
                },
                data[i].selfie_image,
                options,
            );
        }
        

        return selfie_references;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const selfie_references = await db.selfie_references.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.uploaded_at !== undefined) updatePayload.uploaded_at = data.uploaded_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await selfie_references.update(updatePayload, {transaction});

        
        
        if (data.user !== undefined) {
            await selfie_references.setUser(
              
              data.user,
              
              { transaction }
            );
        }
        
        if (data.ai_model !== undefined) {
            await selfie_references.setAi_model(
              
              data.ai_model,
              
              { transaction }
            );
        }
        
        if (data.selfie_embedding !== undefined) {
            await selfie_references.setSelfie_embedding(
              
              data.selfie_embedding,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await selfie_references.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.selfie_references.getTableName(),
                belongsToColumn: 'selfie_image',
                belongsToId: selfie_references.id,
            },
            data.selfie_image,
            options,
        );
        

        return selfie_references;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const selfie_references = await db.selfie_references.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of selfie_references) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of selfie_references) {
                await record.destroy({transaction});
            }
        });


        return selfie_references;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const selfie_references = await db.selfie_references.findByPk(id, options);

        await selfie_references.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await selfie_references.destroy({
            transaction
        });

        return selfie_references;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const selfie_references = await db.selfie_references.findOne(
            { where },
            { transaction },
        );

        if (!selfie_references) {
            return selfie_references;
        }

        const output = selfie_references.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.face_matches_selfie_reference = await selfie_references.getFace_matches_selfie_reference({
            transaction
        });
        
        
        
        
        
        
        
        
        
        output.user = await selfie_references.getUser({
            transaction
        });
        
        
        output.selfie_image = await selfie_references.getSelfie_image({
            transaction
        });
        
        
        output.ai_model = await selfie_references.getAi_model({
            transaction
        });
        
        
        output.selfie_embedding = await selfie_references.getSelfie_embedding({
            transaction
        });
        
        
        output.organizations = await selfie_references.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.users,
        as: 'user',
        
        where: filter.user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.ai_models,
        as: 'ai_model',
        
        where: filter.ai_model ? {
          [Op.or]: [
            { id: { [Op.in]: filter.ai_model.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.ai_model.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.ai_embeddings,
        as: 'selfie_embedding',
        
        where: filter.selfie_embedding ? {
          [Op.or]: [
            { id: { [Op.in]: filter.selfie_embedding.split('|').map(term => Utils.uuid(term)) } },
            {
              vector_ref: {
                [Op.or]: filter.selfie_embedding.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



      {
        model: db.file,
        as: 'selfie_image',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            

            
            

            
            if (filter.uploaded_atRange) {
                const [start, end] = filter.uploaded_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    uploaded_at: {
                    ...where.uploaded_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    uploaded_at: {
                    ...where.uploaded_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      

      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.selfie_references.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'selfie_references',
                        'status',
                        query,
                    ),
                ],
            };
        }

        const records = await db.selfie_references.findAll({
            attributes: [ 'id', 'status' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['status', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.status,
        }));
    }

    
};

